package sun.tools.debug;

public class RemoteDebugger {
   private RemoteAgent agent;

   public RemoteDebugger(String var1, String var2, DebuggerCallback var3, boolean var4) throws Exception {
      this.agent = new RemoteAgent(var1, var2, "", var3, var4);
   }

   public RemoteDebugger(String var1, DebuggerCallback var2, boolean var3) throws Exception {
      if (Agent.isDebuggable()) {
         this.agent = new RemoteAgent(var2, var3);
      } else {
         this.agent = new RemoteAgent("127.0.0.1", (String)null, var1, var2, var3);
      }
   }

   public void close() {
      this.agent.close();
   }

   public RemoteObject get(Integer var1) {
      return this.agent.get(var1);
   }

   public RemoteClass[] listClasses() throws Exception {
      return this.agent.listClasses();
   }

   public RemoteClass findClass(String var1) throws Exception {
      return this.agent.findClass(var1);
   }

   public RemoteThreadGroup[] listThreadGroups(RemoteThreadGroup var1) throws Exception {
      return this.agent.listThreadGroups(var1);
   }

   public void cont() throws Exception {
      this.agent.resumeLastSuspendedThreads();
   }

   // $FF: renamed from: gc (sun.tools.debug.RemoteObject[]) void
   public void method_0(RemoteObject[] var1) throws Exception {
      this.agent.gc(var1);
   }

   public void trace(boolean var1) throws Exception {
      this.agent.trace(var1);
   }

   public void itrace(boolean var1) throws Exception {
      this.agent.itrace(var1);
   }

   public int totalMemory() throws Exception {
      return this.agent.totalMemory();
   }

   public int freeMemory() throws Exception {
      return this.agent.freeMemory();
   }

   public RemoteThreadGroup run(int var1, String[] var2) throws Exception {
      return this.agent.run(var1, var2);
   }

   public String[] listBreakpoints() throws Exception {
      return this.agent.listBreakpoints();
   }

   public String[] getExceptionCatchList() throws Exception {
      return this.agent.getExceptionCatchList();
   }

   public String getSourcePath() throws Exception {
      return this.agent.getSourcePath();
   }

   public void setSourcePath(String var1) throws Exception {
      this.agent.setSourcePath(var1);
   }

   public void addSystemThread() {
      Agent.addSystemThread(Thread.currentThread());
   }

   public void addSystemThread(Thread var1) {
      Agent.addSystemThread(var1);
   }
}
