package sun.tools.debug;

public abstract class RemoteValue implements AgentConstants {
   private int type;

   RemoteValue(int var1) {
      this.type = var1;
   }

   public final int getType() {
      return this.type;
   }

   public final boolean isObject() {
      return this.type == 17 || this.type == 16 || this.type == 19 || this.type == 15 || this.type == 18;
   }

   public final boolean isString() {
      return this.type == 18;
   }

   public abstract String typeName() throws Exception;

   public String description() {
      return this.toString();
   }

   public static String toHex(int var0) {
      char[] var1 = new char[8];
      char[] var2 = new char[10];
      int var3 = 0;

      do {
         int var4 = var0 & 15;
         var1[var3++] = (char)(var4 < 10 ? 48 + var4 : 97 + var4 - 10);
      } while((var0 >>>= 4) > 0);

      var2[0] = '0';
      var2[1] = 'x';
      int var5 = 2;

      while(true) {
         --var3;
         if (var3 < 0) {
            return new String(var2, 0, var5);
         }

         var2[var5++] = var1[var3];
      }
   }

   public static int fromHex(String var0) {
      String var1 = var0.startsWith("0x") ? var0.substring(2).toLowerCase() : var0.toLowerCase();
      if (var0.length() == 0) {
         throw new NumberFormatException();
      } else {
         int var2 = 0;

         for(int var3 = 0; var3 < var1.length(); ++var3) {
            char var4 = var1.charAt(var3);
            if (var4 >= '0' && var4 <= '9') {
               var2 = var2 * 16 + (var4 - 48);
            } else {
               if (var4 < 'a' || var4 > 'f') {
                  throw new NumberFormatException();
               }

               var2 = var2 * 16 + var4 - 97 + 10;
            }
         }

         return var2;
      }
   }
}
